Package org.apache.sysds.runtime.codegen

## Class SpoofMultiAggregate

- java.lang.Object
- - org.apache.sysds.runtime.codegen.SpoofOperator
  - - org.apache.sysds.runtime.codegen.SpoofMultiAggregate

- All Implemented Interfaces:
    `Serializable`

      public abstract class SpoofMultiAggregate
      extends SpoofOperator

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.codegen.SpoofOperator

      `SpoofOperator.SideInput, SpoofOperator.SideInputSparseCell, SpoofOperator.SideInputSparseRow`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SpoofMultiAggregate​(boolean sparseSafe, SpoofCellwise.AggOp... aggOps)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static void` | `aggregatePartialResults​(SpoofCellwise.AggOp[] aggOps, MatrixBlock c, MatrixBlock b)` |
    `SpoofCUDAOperator` | `createCUDAInstrcution​(Integer opID, SpoofCUDAOperator.PrecisionProxy ep)` |
    `MatrixBlock` | `execute​(ArrayList<MatrixBlock> inputs, ArrayList<ScalarObject> scalarObjects, MatrixBlock out)` |
    `MatrixBlock` | `execute​(ArrayList<MatrixBlock> inputs, ArrayList<ScalarObject> scalarObjects, MatrixBlock out, int k)` |
    `MatrixBlock` | `execute​(ArrayList<MatrixBlock> inputs, ArrayList<ScalarObject> scalarObjects, MatrixBlock out, int k, long rix)` |
    `static ValueFunction[]` | `getAggFunctions​(SpoofCellwise.AggOp[] aggOps)` |
    `SpoofCellwise.AggOp[]` | `getAggOps()` |
    `static double` | `getInitialValue​(SpoofCellwise.AggOp aggop)` |
    `String` | `getSpoofType()` |
    `boolean` | `isSparseSafe()` |

    - ### Methods inherited from class org.apache.sysds.runtime.codegen.SpoofOperator

      `execute, execute, getDenseMatrices, getNativeStagingBuffer, getTotalInputNnz, getTotalInputSize`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SpoofMultiAggregate

          public SpoofMultiAggregate​(boolean sparseSafe,
                                     SpoofCellwise.AggOp... aggOps)

  - ### Method Detail

    - #### getAggOps

          public SpoofCellwise.AggOp[] getAggOps()

    - #### isSparseSafe

          public boolean isSparseSafe()

    - #### getSpoofType

          public String getSpoofType()

      Specified by:
        `getSpoofType` in class `SpoofOperator`

    - #### createCUDAInstrcution

          public SpoofCUDAOperator createCUDAInstrcution​(Integer opID,
                                                         SpoofCUDAOperator.PrecisionProxy ep)

      Specified by:
        `createCUDAInstrcution` in class `SpoofOperator`

    - #### execute

          public MatrixBlock execute​(ArrayList<MatrixBlock> inputs,
                                     ArrayList<ScalarObject> scalarObjects,
                                     MatrixBlock out)

      Specified by:
        `execute` in class `SpoofOperator`

    - #### execute

          public MatrixBlock execute​(ArrayList<MatrixBlock> inputs,
                                     ArrayList<ScalarObject> scalarObjects,
                                     MatrixBlock out,
                                     int k)

      Overrides:
        `execute` in class `SpoofOperator`

    - #### execute

          public MatrixBlock execute​(ArrayList<MatrixBlock> inputs,
                                     ArrayList<ScalarObject> scalarObjects,
                                     MatrixBlock out,
                                     int k,
                                     long rix)

    - #### getInitialValue

          public static double getInitialValue​(SpoofCellwise.AggOp aggop)

    - #### aggregatePartialResults

          public static void aggregatePartialResults​(SpoofCellwise.AggOp[] aggOps,
                                                     MatrixBlock c,
                                                     MatrixBlock b)

    - #### getAggFunctions

          public static ValueFunction[] getAggFunctions​(SpoofCellwise.AggOp[] aggOps)